/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
// setup.h : main header file for the SETUP DLL
//


#ifndef REGISTRY_H
    #define REGISTRY_H

#include "customization.h"
    //
    // IMPORTANT: Don't change the indentation of this file!! 
    //
    
    /*
    * the following define could seem reduntant but needs to have the possibility
    * to customize the plug-in with different information. The 
    * The UI_EXECUTABLE_NAME must be the same that is in the .inf file %Prov% property
    * The PROGRAM_REGISTRY is the main root of the registry. It is the same in .inf file %AppRegistry%
    * The PROGRAM_DIR is the main folder on file system. It is the same in .inf file %InstDir%
    */
    
    #define UI_EXECUTABLE_NAME  TEXT("Funambol")    // the name of the main UI program
    #define PROGRAM_DIR         TEXT("Funambol")    // directory folder on file system
    #define PROGRAM_REGISTRY    TEXT("Funambol")    // main registry key

    /*
    * The SERVICE_TYPE is the name of the mail transport. it is the same in customization.h 
    */    
    //#define SERVICE_TYPE                "SyncML"
    #define SYNCML_TRANSPORT_REGISTRY   TEXT("SOFTWARE\\Microsoft\\Inbox\\Svc\\") TEXT(SERVICE_TYPE) 
    
    /* 
     * backward compatibility
     */
    //#define DEFAULT_ACCOUNT_NAME            TEXT("Funambol")
    #define OLD_SERVICE_TYPE                "Funambol"
    #define SYNCML_OLD_TRANSPORT_REGISTRY   TEXT("SOFTWARE\\Microsoft\\Inbox\\Svc\\") TEXT(OLD_SERVICE_TYPE) 
    
    // is the registry bkp
    #define PROGRAM_REGISTRY_BKP    PROGRAM_REGISTRY TEXT("Bkp");

    #define ROOT_TREE               TEXT("SyncclientPIM")
    #define BASE_ROOT_TREE          TEXT("Software\\%s\\") ROOT_TREE
    #define TREE_SOURCE_PICTURE     TEXT("\\spds\\sources\\pictures")
    #define TREE_SOURCE_CONTACTS    TEXT("\\spds\\sources\\contacts")
    #define TREE_SOURCE_CALENDAR    TEXT("\\spds\\sources\\appointments")
    #define TREE_SOURCE_TASKS       TEXT("\\spds\\sources\\tasks")
    #define TREE_SOURCE_NOTES       TEXT("\\spds\\sources\\notes")
    #define TREE_SOURCE_BRIEFCASE   TEXT("\\spds\\sources\\briefcase")
    #define TREE_SOURCE_MAILS       TEXT("\\spds\\sources\\mails")
    #define TREE_SOURCE_CONFIG      TEXT("\\spds\\sources\\config")
    #define TREE_SOURCE_AUTH        TEXT("\\spds\\syncml\\Auth")
    #define TREE_SOURCE_CONN        TEXT("\\spds\\syncml\\Conn")
    #define TREE_SOURCE_DEVINFO     TEXT("\\spds\\syncml\\DevInfo")
    #define TREE_SOURCE_DEVDETAIL   TEXT("\\spds\\syncml\\DevDetail")
    #define TREE_SOURCE_EXT         TEXT("\\spds\\syncml\\Ext")
    #define TREE_SERVER_EXT         TEXT("\\server\\Ext")


    #define ROOT_TREE_PICTURES      ROOT_TREE   TREE_SOURCE_PICTURE
    #define ROOT_TREE_CONTACTS      ROOT_TREE   TREE_SOURCE_CONTACTS
    #define ROOT_TREE_CALENDAR      ROOT_TREE   TREE_SOURCE_CALENDAR 
    #define ROOT_TREE_TASKS         ROOT_TREE   TREE_SOURCE_TASKS 
    #define ROOT_TREE_NOTES         ROOT_TREE   TREE_SOURCE_NOTES
    #define ROOT_TREE_BRIEFCASE     ROOT_TREE   TREE_SOURCE_BRIEFCASE
    #define ROOT_TREE_MAILS         ROOT_TREE   TREE_SOURCE_MAILS
    #define ROOT_TREE_CONFIG        ROOT_TREE   TREE_SOURCE_CONFIG
    #define ROOT_TREE_AUTH          ROOT_TREE   TREE_SOURCE_AUTH
    #define ROOT_TREE_CONN          ROOT_TREE   TREE_SOURCE_CONN
    #define ROOT_TREE_DEVINFO       ROOT_TREE   TREE_SOURCE_DEVINFO
    #define ROOT_TREE_DEVDETAIL     ROOT_TREE   TREE_SOURCE_DEVDETAIL
    #define ROOT_TREE_EXT           ROOT_TREE   TREE_SOURCE_EXT
    #define ROOT_TREE_SERVER_EXT    ROOT_TREE   TREE_SERVER_EXT


    /*
    * 
    */
    #define OLD_FUN_PLUG_IN_NAME        TEXT("Funambol Plug-in")    
    
    #define KEY_VALUE_LENGTH            512

    void setPropertyValue(const wchar_t*  context, const wchar_t*  prop, const wchar_t* value, bool backup = false);
    wchar_t* readPropertyValue(const wchar_t* fullContext, const wchar_t*  prop);
    void createAllRegistry(bool backup = false);
    void createPictureSettings(bool backup = false);
    void createAllRegistryBackup();
    void deleteAllRegistry();
    void updateNewRegistry();

    void deleteSyncmlTransportRegistry();

    void deleteAllRegistry();

    void createSyncmlTransportRegistry();
    const wchar_t* getAppName();
    
    /**
    * The val contains the %s that is substituted with the name of the registry root (tipically Funambol)
    */
    const wchar_t* getFullReg(wchar_t* val);
    
    /**
    * The val contains the %s that is substituted with the name of the registry root bkp (tipically FunambolBkp)
    */
    const wchar_t* getFullRegBkp(wchar_t* val);
    
    /**
    * Return the constant that return the registry of the root (tipically Funambol)
    */
    const wchar_t* getRegistryRoot();
    
    /**
    * Flush the registry and persists on the registry all the modifications
    */
    void flushRegistry();

    static size_t getLenEncoding(const WCHAR* s);
    char* toMultibyte(const WCHAR *wc);  
    WCHAR* toWideChar(const char *mb);
    
    bool backupRegistryVersion();
    bool restoreRegistryVersion();
    bool removeBackupRegistryVersion();
    bool removeEntryOfUninstallDifferentName(wchar_t* installedName);

    /// Removes the node from win registry, and recursively all its subnodes.
    void removeRegistryNode(const WCHAR* fullPath);

    wchar_t** getChildrenNames();


#endif
