/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */


#include "StdAfx.h"
#include "SyncmlMailSettings.h"
#include "customization.h"
#include "windows.h"
#include "base/Log.h"
#include "resource.h"
#include "CSettings.h"

#ifdef WIN32_PLATFORM_WFSP
#include "funresourcesp.h"
#endif
#ifdef WIN32_PLATFORM_PSPC
#include "funresourceppc.h"
#endif

long CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

#define ID_TEXT   200
#define EDITID    1000

LPWORD lpwAlign(LPWORD lpIn)
{
    ULONG ul;

    ul = (ULONG)lpIn;
    ul ++;
    ul >>=1;
    ul <<=1;
    return (LPWORD)ul;
}

LRESULT DisplayMyMessage2(HINSTANCE hinst, HWND hwndOwner, LPSTR lpszMessage)
{
    if (hinst == NULL) {
        hinst = (HINSTANCE)GetModuleHandle(NULL);
    }
    HGLOBAL hgbl;
    LPDLGTEMPLATE lpdt;
    LPDLGITEMTEMPLATE lpdit;
    LPWORD lpw;
    LPWSTR lpwsz;
    LRESULT ret;
    int nchar;

    hgbl = GlobalAlloc(GMEM_ZEROINIT, 1024);
    if (!hgbl)
        return -1;
 
    lpdt = (LPDLGTEMPLATE)GlobalLock(hgbl);
 
    // Define a dialog box.
 
    lpdt->style = WS_POPUP | WS_BORDER | WS_SYSMENU | DS_MODALFRAME | WS_CAPTION;
    lpdt->cdit = 5;         // Number of controls
    lpdt->x  = 0;  lpdt->y  = 0;
    lpdt->cx = 200; lpdt->cy = 200;

    lpw = (LPWORD)(lpdt + 1);
    *lpw++ = 0;             // No menu
    *lpw++ = 0;             // Predefined dialog box class (by default)

    lpwsz = (LPWSTR)lpw;
    nchar = 1 + MultiByteToWideChar(CP_ACP, 0, "Options", -1, lpwsz, 50);
    lpw += nchar;
    
    //-----------------------
    // Define an OK button.
    //-----------------------
    lpw = lpwAlign(lpw);    // Align DLGITEMTEMPLATE on DWORD boundary
    lpdit = (LPDLGITEMTEMPLATE)lpw;
    lpdit->x  = 10; lpdit->y  = 70;
    lpdit->cx = 80; lpdit->cy = 20;
    lpdit->id = IDOK;       // OK button identifier
    lpdit->style = WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON;

    lpw = (LPWORD)(lpdit + 1);
    *lpw++ = 0xFFFF;
    *lpw++ = 0x0080;        // Button class

    lpwsz = (LPWSTR)lpw;
    nchar = 1 + MultiByteToWideChar(CP_ACP, 0, "OK", -1, lpwsz, 50);
    lpw += nchar;
    lpw = lpwAlign(lpw);    // Align creation data on DWORD boundary
    *lpw++ = 0;             // No creation data
/*
    //-----------------------
    // Define a Help button.
    //-----------------------
    lpw = lpwAlign(lpw);    // Align DLGITEMTEMPLATE on DWORD boundary
    lpdit = (LPDLGITEMTEMPLATE)lpw;
    lpdit->x  = 55; lpdit->y  = 10;
    lpdit->cx = 40; lpdit->cy = 20;
    lpdit->id = ID_HELP;    // Help button identifier
    lpdit->style = WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON;

    lpw = (LPWORD)(lpdit + 1);
    *lpw++ = 0xFFFF;
    *lpw++ = 0x0080;        // Button class atom

    lpwsz = (LPWSTR)lpw;
    nchar = 1 + MultiByteToWideChar(CP_ACP, 0, "Help", -1, lpwsz, 50);
    lpw += nchar;
    lpw = lpwAlign(lpw);    // Align creation data on DWORD boundary
    *lpw++ = 0;             // No creation data
*/
    //-----------------------
    // Define a 1-EDIT text control.
    //-----------------------
    DWORD dwStyle = WS_CHILD | WS_VISIBLE | 
                WS_BORDER | ES_LEFT ;  

    lpw = lpwAlign(lpw);    // Align DLGITEMTEMPLATE on DWORD boundary
    lpdit = (LPDLGITEMTEMPLATE)lpw;
    lpdit->x  = 10; lpdit->y  = 10;
    lpdit->cx = 40; lpdit->cy = 15;
    lpdit->id = EDITID;    // Text identifier
    lpdit->style = dwStyle;    

    lpw = (LPWORD)(lpdit + 1);
    *lpw++ = 0xFFFF;
    *lpw++ = 0x0081;        // Edit class
    // *lpw++ = 0x0082;        // Static class

    for (lpwsz = (LPWSTR)lpw; *lpwsz++ = (WCHAR)*lpszMessage++;);
    lpw = (LPWORD)lpwsz;
    lpw = lpwAlign(lpw);    // Align creation data on DWORD boundary
    *lpw++ = 0;             // No creation data

    //-----------------------
    // Define a 2-EDIT text control.
    //-----------------------   
    lpw = lpwAlign(lpw);    // Align DLGITEMTEMPLATE on DWORD boundary
    lpdit = (LPDLGITEMTEMPLATE)lpw;
    lpdit->x  = 10; lpdit->y  = 30;
    lpdit->cx = 40; lpdit->cy = 15;
    lpdit->id = EDITID;    // Text identifier
    lpdit->style = dwStyle;    

    lpw = (LPWORD)(lpdit + 1);
    *lpw++ = 0xFFFF;
    *lpw++ = 0x0081;        // Edit class
    // *lpw++ = 0x0082;        // Static class

    for (lpwsz = (LPWSTR)lpw; *lpwsz++ = (WCHAR)*lpszMessage++;);
    lpw = (LPWORD)lpwsz;
    lpw = lpwAlign(lpw);    // Align creation data on DWORD boundary
    *lpw++ = 0;             // No creation data

    GlobalUnlock(hgbl); 
   
    ret = DialogBoxIndirect(hinst, 
                           (LPDLGTEMPLATE)hgbl, 
                           hwndOwner, 
                           (DLGPROC)WndProc); 
    
    GlobalFree(hgbl); 
    return ret; 
    
    
}



LRESULT DisplayMyMessage(HINSTANCE hinst, HWND hwndOwner, LPSTR lpszMessage) {
    /*
    AFX_MANAGE_STATE(AfxGetAppModuleState());        
    //HINSTANCE tmp = AfxGetResourceHandle();
    AfxSetResourceHandle(hinst);
    
    //AFX_MANAGE_STATE(AfxGetAppModuleState());
    CWnd* pWnd = CWnd::FromHandle(hwndOwner);
        
    
    s = new CSettings();
    BOOL ret = s->Create(IDD_SYNC_MAIL_SETTINGS, pWnd);     

    //HWND hwnd = set.GetSafeHwnd();
    //SetForegroundWindow(hwnd); 
    
    //INT_PTR result = set.ShowWindow(SW_SHOW);
    return 0 ;
    */
    return 0;

}



LRESULT DisplayMyMessage3(HINSTANCE hinst, HWND hwndOwner, LPSTR lpszMessage) {
    AFX_MANAGE_STATE(AfxGetAppModuleState());        
    //HINSTANCE tmp = AfxGetResourceHandle();
    AfxSetResourceHandle(hinst);
    //AFX_MANAGE_STATE(AfxGetAppModuleState());
    CWnd* pWnd = CWnd::FromHandle(hwndOwner);
    //pWnd->BeginModalState();

    //Settings set;        
    //set.DoModal();
   
    //Settings* s  = new Settings();
    //BOOL ret = s->Create(IDD_SYNC_MAIL_SETTINGS, pWnd);               
    //s->ShowWindow(SW_SHOW);    
    
    //HWND hwnd = set.GetSafeHwnd();
    //SetForegroundWindow(hwnd); 
    
    //INT_PTR result = set.ShowWindow(SW_SHOW);
    return (LRESULT)DialogBox(hinst, MAKEINTRESOURCE(IDD_SYNC_MAIL_SETTINGS), 
                              hwndOwner, (DLGPROC)WndProc);

}













BOOL CALLBACK ToolDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
    switch(Message)
    {
        case WM_COMMAND:
#if 0
            switch(LOWORD(wParam))
            {   
            default:
                break;
            }
#endif
        break;
        default:
            return FALSE;
    }
    return TRUE;
}

extern "C" DWORD WINAPI createCustomSettings(LPVOID lpv, HINSTANCE hinst, HWND hwndParent) {
    

    HANDLE moduleHandle = hinst;

    WNDCLASS wc;
    
    // Just to be safe, remove a lost icon.. (works on ppc only)


    LPCWSTR lpszClassName= L"syncmlmailsettings";
    moduleHandle = GetModuleHandle(0);

    // Init Wnd class
    wc.style=CS_HREDRAW | CS_VREDRAW ;
    wc.lpfnWndProc=WndProc;
    wc.cbClsExtra=0;
    wc.cbWndExtra=0;
    wc.hInstance=(HINSTANCE)moduleHandle;
    wc.hIcon=0;
    wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName=NULL;
    wc.lpszClassName=lpszClassName;

    if(!RegisterClass(&wc)) return false;
    
    HWND hMainWindow = CreateWindow(
                                TEXT("syncmlmailsettings"),
                                TEXT("Options"),
                                WS_DLGFRAME | WS_BORDER | WS_SYSMENU | DS_MODALFRAME | WS_CAPTION | WS_MAXIMIZE,
                                // WS_POPUP | WS_SYSMENU | WS_CAPTION | DS_MODALFRAME,     // window style
      CW_USEDEFAULT,           // initial x position
      CW_USEDEFAULT,           // initial y position
      CW_USEDEFAULT,           // initial x size
      CW_USEDEFAULT,           // initial y size

                                hwndParent,
                                NULL,
                                (HINSTANCE)moduleHandle,
                                NULL);
        if(!hMainWindow)
        return FALSE;
    
    BOOL res = ShowWindow(hMainWindow, SW_SHOW);    
    res = UpdateWindow(hMainWindow);
    res = SetForegroundWindow(hMainWindow);
             
    
    return 0;

}
 

//
// It listens to the message event and processes the action to do
// return -6 if the user terminates the application
//
long CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;
    HDC hdc;
    TCHAR greeting[] = _T("Hello, World!");


    int ret = 0;
    switch(msg) {

        case WM_DESTROY:
        case WM_CLOSE:
        case WM_QUIT:
            PostQuitMessage(0);
            return 0;

        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);

            // Here your application is laid out.
            // For this introduction, we just print out "Hello, World!"
            // in the top left corner.
            //TextOut(hdc,
            //    5, 5,
            //    greeting, _tcslen(greeting));
            // End application specific layout section.

            EndPaint(hWnd, &ps);
        break;
       
    }
    return DefWindowProc(hWnd,msg,wParam,lParam);
}


